/* This function returns various types of time.
   Callable by Fortran routines. */

void gettime_(double *tarray)
/* tarray[0]=User time, tarray[1]=Sys time, tarray[2]=Elapsed time,
   all expressed in seconds */
{
#include <sys/time.h>

  struct timeval tv;

#ifdef USETIMES  /*==================================================*/

#include <sys/times.h>
#include <unistd.h>

  struct tms ts;
  static double ClockTick=0.0;

  if (ClockTick == 0.0) ClockTick = (double) sysconf(_SC_CLK_TCK);
  if ( times(&ts) == -1 ) {
    tarray[0]=tarray[1]=0.0;
  } else {
    tarray[0] = (double) ts.tms_utime / ClockTick;
    tarray[1] = 0.0;
  }

#else            /*==================================================*/

#include <sys/resource.h>
    /* For Solaris */
/*#include </usr/ucbinclude/sys/rusage.h> */
  struct rusage RU;

  getrusage(RUSAGE_SELF, &RU);
  tarray[0]=RU.ru_utime.tv_sec + (double)RU.ru_utime.tv_usec*1e-6;
  tarray[1]=RU.ru_stime.tv_sec + (double)RU.ru_stime.tv_usec*1e-6;

#endif           /*==================================================*/

  gettimeofday(&tv, (struct timezone *)0);
  tarray[2]=tv.tv_sec+(double)tv.tv_usec*1e-6;

  return;
}

/* =================================================================

For DAWN1000 nf77

  double dclock_();
  tarray[0]=tarray[1]=tarray[2]=dclock_();

====================================================================*/
